/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JDialog.java to edit this template
 */
package it.unibas.digitalFileControl.views;

import it.unibas.digitalFileControl.Application;
import it.unibas.digitalFileControl.model.Document;
import it.unibas.digitalFileControl.model.Enumerator;
import it.unibas.digitalFileControl.model.UserDocument;
import it.unibas.digitalFileControl.model.AuthorizedUsersTableModel;
import it.unibas.digitalFileControl.model.UnauthorizedUsersTableModel;
import it.unibas.digitalFileControl.model.User;
import java.text.SimpleDateFormat;
import java.util.List;
import javax.swing.JTable;

/**
 *
 * @author Gabriele D
 */
public class DocumentDetailDialog extends javax.swing.JDialog {

    /**
     * Creates new form DocumentDetailDialog
     */
    public DocumentDetailDialog(java.awt.Frame parent) {
        super(parent, true);       
    }
    
    public void init() {
        initComponents();
        this.pack();
        this.setLocationRelativeTo(getParent());
        initTables();
        setActions();
    }
    
    private void initTables() {
        AuthorizedUsersTableModel authorizedModel = new AuthorizedUsersTableModel();
        this.authorizedUsersTable.setModel(authorizedModel);
        UnauthorizedUsersTableModel unauthorizedModel = new UnauthorizedUsersTableModel();
        this.unauthorizedUsersTable.setModel(unauthorizedModel);
    }
    
    public void showDialog() {
        this.setVisible(true);
    }
    
    public void hideDialog() {
        this.setVisible(false);
    }
    
    public void setDocumentDetails(Document document) {
        this.documentNameLabel.setText(document.getName());
        this.descriptionLabel.setText(document.getDescription());
        
        SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy");
        if(document.getCreationDate() != null) {
            this.creationDateLabel.setText(formatter.format(document.getCreationDate()));
        } else {
            this.creationDateLabel.setText("Non definito");
        }
        
        if(document.getExpirationTime() != null)
        {
            this.expirationDateLabel.setText(formatter.format(document.getExpirationTime()));
        } else {
            this.expirationDateLabel.setText("Non definito");
        }
    }
    
    public void loadTablesData() {
        List<UserDocument> userDocumentList = (List<UserDocument>) Application.getInstance().getLocalStorage().getBeans(Enumerator.Storage.DETAILS_USERDOCUMENTS);
        AuthorizedUsersTableModel authorizedModel = (AuthorizedUsersTableModel)this.authorizedUsersTable.getModel();
        authorizedModel.setUserDocumentsList(userDocumentList);
        authorizedModel.reloadTable();
        
        List<User> unauthorizedUsersList = (List<User>) Application.getInstance().getLocalStorage().getBeans(Enumerator.Storage.DETAILS_UNAUTHORIZED_USERS);
        UnauthorizedUsersTableModel unauthorizedModel = (UnauthorizedUsersTableModel)this.unauthorizedUsersTable.getModel();
        unauthorizedModel.setUsersList(unauthorizedUsersList);
        unauthorizedModel.reloadTable();
    }
    
    public int getSelectedUserDocument() {
        return this.authorizedUsersTable.getSelectedRow();
    }
    
    public int getSelectedUnauthorizedUser() {
        return this.unauthorizedUsersTable.getSelectedRow();
    }
    
    public JTable getAuthorizedUsersTable() {
        return this.authorizedUsersTable;
    }
    
    public JTable getUnauthorizedUsersTable() {
        return this.unauthorizedUsersTable;
    }
    
    private void setActions() {
        Application.getInstance().getDocumentDetailControl().setAuthorizedTableRemoveUserAction();
        Application.getInstance().getDocumentDetailControl().setUnhautorizedTableAddUserAction();
        this.newUserButton.setAction(Application.getInstance().getDocumentDetailControl().getOpenNewUserDialogAction());
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel3 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        documentNameLabel = new javax.swing.JLabel();
        descriptionLabel = new javax.swing.JLabel();
        creationDateLabel = new javax.swing.JLabel();
        expirationDateLabel = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        authorizedUsersTable = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        unauthorizedUsersTable = new javax.swing.JTable();
        newUserButton = new javax.swing.JButton();

        jLabel3.setText("jLabel3");

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Dettaglio documento");

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel1.setText("NOME DOCUMENTO:");

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel2.setText("DESCRIZIONE:");

        jLabel5.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel5.setText("DATA SCADENZA:");

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel4.setText("DATA CREAZIONE:");

        documentNameLabel.setText("jLabel5");

        descriptionLabel.setText("jLabel2");

        creationDateLabel.setText("jLabel6");

        expirationDateLabel.setText("jLabel6");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Utenti autorizzati", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        authorizedUsersTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(authorizedUsersTable);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 696, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(20, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Utenti non autorizzati", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        unauthorizedUsersTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(unauthorizedUsersTable);

        newUserButton.setText("Nuovo utente");
        newUserButton.setFocusable(false);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(newUserButton)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 127, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(newUserButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(descriptionLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(18, 18, 18)
                        .addComponent(documentNameLabel)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 242, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(expirationDateLabel)
                    .addComponent(creationDateLabel))
                .addGap(142, 142, 142))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(19, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel4)
                    .addComponent(documentNameLabel)
                    .addComponent(creationDateLabel))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabel5)
                    .addComponent(descriptionLabel)
                    .addComponent(expirationDateLabel))
                .addGap(40, 40, 40)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable authorizedUsersTable;
    private javax.swing.JLabel creationDateLabel;
    private javax.swing.JLabel descriptionLabel;
    private javax.swing.JLabel documentNameLabel;
    private javax.swing.JLabel expirationDateLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JButton newUserButton;
    private javax.swing.JTable unauthorizedUsersTable;
    // End of variables declaration//GEN-END:variables
}
